{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "-9",
                "-p",
                "8",
                "-c"
            ],
            "hints": [
                {
                    "dockerPull": "bytesco/pigz",
                    "class": "DockerRequirement"
                },
                {
                    "coresMin": 8,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#compress-file.cwl/input_file"
                }
            ],
            "stdout": "compressed.gz",
            "id": "#compress-file.cwl",
            "outputs": [
                {
                    "type": "File",
                    "id": "#compress-file.cwl/compressed_file",
                    "outputBinding": {
                        "glob": "compressed.gz"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "cat",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#concatenate-files.cwl/files"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#concatenate-files.cwl/concatenated_file",
                    "outputBinding": {
                        "glob": "concatenated.txt"
                    }
                }
            ],
            "stdout": "concatenated.txt",
            "id": "#concatenate-files.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/script_file",
                    "type": "File"
                },
                {
                    "id": "#main/script_arguments",
                    "type": {
                        "type": "array",
                        "items": "string"
                    }
                }
            ],
            "steps": [
                {
                    "run": "#compress-file.cwl",
                    "in": [
                        {
                            "source": "#main/concat/concatenated_file",
                            "id": "#main/compress/input_file"
                        }
                    ],
                    "out": [
                        "#main/compress/compressed_file"
                    ],
                    "id": "#main/compress"
                },
                {
                    "run": "#concatenate-files.cwl",
                    "in": [
                        {
                            "source": "#main/sort/sorted_file",
                            "id": "#main/concat/files"
                        }
                    ],
                    "out": [
                        "#main/concat/concatenated_file"
                    ],
                    "id": "#main/concat"
                },
                {
                    "run": "#run-script.cwl",
                    "scatter": "#main/scripts/arg",
                    "in": [
                        {
                            "source": "#main/script_arguments",
                            "id": "#main/scripts/arg"
                        },
                        {
                            "source": "#main/script_file",
                            "id": "#main/scripts/src"
                        }
                    ],
                    "out": [
                        "#main/scripts/script_output"
                    ],
                    "id": "#main/scripts"
                },
                {
                    "run": "#sort-file.cwl",
                    "scatter": "#main/sort/input_file",
                    "in": [
                        {
                            "source": "#main/scripts/script_output",
                            "id": "#main/sort/input_file"
                        }
                    ],
                    "out": [
                        "#main/sort/sorted_file"
                    ],
                    "id": "#main/sort"
                }
            ],
            "outputs": [
                {
                    "id": "#main/output",
                    "type": "File",
                    "outputSource": "#main/compress/compressed_file"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "node",
            "hints": [
                {
                    "dockerPull": "node:slim",
                    "class": "DockerRequirement"
                },
                {
                    "coresMax": 1,
                    "ramMin": 2000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#run-script.cwl/arg"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#run-script.cwl/src"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#run-script.cwl/script_output",
                    "outputBinding": {
                        "glob": "output.txt"
                    }
                }
            ],
            "stdout": "output.txt",
            "id": "#run-script.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "sort"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "coresMax": 1,
                    "outdirMin": "$(parseInt(Math.ceil(inputs.input_file.size / Math.pow(2, 20))))",
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#sort-file.cwl/input_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#sort-file.cwl/sorted_file",
                    "outputBinding": {
                        "glob": "sorted.txt"
                    }
                }
            ],
            "stdout": "sorted.txt",
            "id": "#sort-file.cwl"
        }
    ],
    "cwlVersion": "v1.2"
}
